4 İşlemeler

Yazar SHA1 Mesaj Tarih
  Ahmad Rusdi 549d44aca6 Merge branch 'master' of https://git.zipcode.rocks/woat/Passion-Project 6 yıl önce
  Ahmad Rusdi c548f7c17d news controller advice 6 yıl önce
  Ahmad Rusdi 6b69a3047d increased test coverage for news 6 yıl önce
  Ahmad Rusdi 1b0daf0e2c news 6 yıl önce

+ 25
- 0
server/.gitignore Dosyayı Görüntüle

@@ -0,0 +1,25 @@
1
+/target/
2
+!.mvn/wrapper/maven-wrapper.jar
3
+
4
+### STS ###
5
+.apt_generated
6
+.classpath
7
+.factorypath
8
+.project
9
+.settings
10
+.springBeans
11
+.sts4-cache
12
+
13
+### IntelliJ IDEA ###
14
+.idea
15
+*.iws
16
+*.iml
17
+*.ipr
18
+
19
+### NetBeans ###
20
+/nbproject/private/
21
+/build/
22
+/nbbuild/
23
+/dist/
24
+/nbdist/
25
+/.nb-gradle/

BIN
server/.mvn/wrapper/maven-wrapper.jar Dosyayı Görüntüle


+ 1
- 0
server/.mvn/wrapper/maven-wrapper.properties Dosyayı Görüntüle

@@ -0,0 +1 @@
1
+distributionUrl=https://repo1.maven.org/maven2/org/apache/maven/apache-maven/3.5.3/apache-maven-3.5.3-bin.zip

+ 225
- 0
server/mvnw Dosyayı Görüntüle

@@ -0,0 +1,225 @@
1
+#!/bin/sh
2
+# ----------------------------------------------------------------------------
3
+# Licensed to the Apache Software Foundation (ASF) under one
4
+# or more contributor license agreements.  See the NOTICE file
5
+# distributed with this work for additional information
6
+# regarding copyright ownership.  The ASF licenses this file
7
+# to you under the Apache License, Version 2.0 (the
8
+# "License"); you may not use this file except in compliance
9
+# with the License.  You may obtain a copy of the License at
10
+#
11
+#    http://www.apache.org/licenses/LICENSE-2.0
12
+#
13
+# Unless required by applicable law or agreed to in writing,
14
+# software distributed under the License is distributed on an
15
+# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
16
+# KIND, either express or implied.  See the License for the
17
+# specific language governing permissions and limitations
18
+# under the License.
19
+# ----------------------------------------------------------------------------
20
+
21
+# ----------------------------------------------------------------------------
22
+# Maven2 Start Up Batch script
23
+#
24
+# Required ENV vars:
25
+# ------------------
26
+#   JAVA_HOME - location of a JDK home dir
27
+#
28
+# Optional ENV vars
29
+# -----------------
30
+#   M2_HOME - location of maven2's installed home dir
31
+#   MAVEN_OPTS - parameters passed to the Java VM when running Maven
32
+#     e.g. to debug Maven itself, use
33
+#       set MAVEN_OPTS=-Xdebug -Xrunjdwp:transport=dt_socket,server=y,suspend=y,address=8000
34
+#   MAVEN_SKIP_RC - flag to disable loading of mavenrc files
35
+# ----------------------------------------------------------------------------
36
+
37
+if [ -z "$MAVEN_SKIP_RC" ] ; then
38
+
39
+  if [ -f /etc/mavenrc ] ; then
40
+    . /etc/mavenrc
41
+  fi
42
+
43
+  if [ -f "$HOME/.mavenrc" ] ; then
44
+    . "$HOME/.mavenrc"
45
+  fi
46
+
47
+fi
48
+
49
+# OS specific support.  $var _must_ be set to either true or false.
50
+cygwin=false;
51
+darwin=false;
52
+mingw=false
53
+case "`uname`" in
54
+  CYGWIN*) cygwin=true ;;
55
+  MINGW*) mingw=true;;
56
+  Darwin*) darwin=true
57
+    # Use /usr/libexec/java_home if available, otherwise fall back to /Library/Java/Home
58
+    # See https://developer.apple.com/library/mac/qa/qa1170/_index.html
59
+    if [ -z "$JAVA_HOME" ]; then
60
+      if [ -x "/usr/libexec/java_home" ]; then
61
+        export JAVA_HOME="`/usr/libexec/java_home`"
62
+      else
63
+        export JAVA_HOME="/Library/Java/Home"
64
+      fi
65
+    fi
66
+    ;;
67
+esac
68
+
69
+if [ -z "$JAVA_HOME" ] ; then
70
+  if [ -r /etc/gentoo-release ] ; then
71
+    JAVA_HOME=`java-config --jre-home`
72
+  fi
73
+fi
74
+
75
+if [ -z "$M2_HOME" ] ; then
76
+  ## resolve links - $0 may be a link to maven's home
77
+  PRG="$0"
78
+
79
+  # need this for relative symlinks
80
+  while [ -h "$PRG" ] ; do
81
+    ls=`ls -ld "$PRG"`
82
+    link=`expr "$ls" : '.*-> \(.*\)$'`
83
+    if expr "$link" : '/.*' > /dev/null; then
84
+      PRG="$link"
85
+    else
86
+      PRG="`dirname "$PRG"`/$link"
87
+    fi
88
+  done
89
+
90
+  saveddir=`pwd`
91
+
92
+  M2_HOME=`dirname "$PRG"`/..
93
+
94
+  # make it fully qualified
95
+  M2_HOME=`cd "$M2_HOME" && pwd`
96
+
97
+  cd "$saveddir"
98
+  # echo Using m2 at $M2_HOME
99
+fi
100
+
101
+# For Cygwin, ensure paths are in UNIX format before anything is touched
102
+if $cygwin ; then
103
+  [ -n "$M2_HOME" ] &&
104
+    M2_HOME=`cygpath --unix "$M2_HOME"`
105
+  [ -n "$JAVA_HOME" ] &&
106
+    JAVA_HOME=`cygpath --unix "$JAVA_HOME"`
107
+  [ -n "$CLASSPATH" ] &&
108
+    CLASSPATH=`cygpath --path --unix "$CLASSPATH"`
109
+fi
110
+
111
+# For Migwn, ensure paths are in UNIX format before anything is touched
112
+if $mingw ; then
113
+  [ -n "$M2_HOME" ] &&
114
+    M2_HOME="`(cd "$M2_HOME"; pwd)`"
115
+  [ -n "$JAVA_HOME" ] &&
116
+    JAVA_HOME="`(cd "$JAVA_HOME"; pwd)`"
117
+  # TODO classpath?
118
+fi
119
+
120
+if [ -z "$JAVA_HOME" ]; then
121
+  javaExecutable="`which javac`"
122
+  if [ -n "$javaExecutable" ] && ! [ "`expr \"$javaExecutable\" : '\([^ ]*\)'`" = "no" ]; then
123
+    # readlink(1) is not available as standard on Solaris 10.
124
+    readLink=`which readlink`
125
+    if [ ! `expr "$readLink" : '\([^ ]*\)'` = "no" ]; then
126
+      if $darwin ; then
127
+        javaHome="`dirname \"$javaExecutable\"`"
128
+        javaExecutable="`cd \"$javaHome\" && pwd -P`/javac"
129
+      else
130
+        javaExecutable="`readlink -f \"$javaExecutable\"`"
131
+      fi
132
+      javaHome="`dirname \"$javaExecutable\"`"
133
+      javaHome=`expr "$javaHome" : '\(.*\)/bin'`
134
+      JAVA_HOME="$javaHome"
135
+      export JAVA_HOME
136
+    fi
137
+  fi
138
+fi
139
+
140
+if [ -z "$JAVACMD" ] ; then
141
+  if [ -n "$JAVA_HOME"  ] ; then
142
+    if [ -x "$JAVA_HOME/jre/sh/java" ] ; then
143
+      # IBM's JDK on AIX uses strange locations for the executables
144
+      JAVACMD="$JAVA_HOME/jre/sh/java"
145
+    else
146
+      JAVACMD="$JAVA_HOME/bin/java"
147
+    fi
148
+  else
149
+    JAVACMD="`which java`"
150
+  fi
151
+fi
152
+
153
+if [ ! -x "$JAVACMD" ] ; then
154
+  echo "Error: JAVA_HOME is not defined correctly." >&2
155
+  echo "  We cannot execute $JAVACMD" >&2
156
+  exit 1
157
+fi
158
+
159
+if [ -z "$JAVA_HOME" ] ; then
160
+  echo "Warning: JAVA_HOME environment variable is not set."
161
+fi
162
+
163
+CLASSWORLDS_LAUNCHER=org.codehaus.plexus.classworlds.launcher.Launcher
164
+
165
+# traverses directory structure from process work directory to filesystem root
166
+# first directory with .mvn subdirectory is considered project base directory
167
+find_maven_basedir() {
168
+
169
+  if [ -z "$1" ]
170
+  then
171
+    echo "Path not specified to find_maven_basedir"
172
+    return 1
173
+  fi
174
+
175
+  basedir="$1"
176
+  wdir="$1"
177
+  while [ "$wdir" != '/' ] ; do
178
+    if [ -d "$wdir"/.mvn ] ; then
179
+      basedir=$wdir
180
+      break
181
+    fi
182
+    # workaround for JBEAP-8937 (on Solaris 10/Sparc)
183
+    if [ -d "${wdir}" ]; then
184
+      wdir=`cd "$wdir/.."; pwd`
185
+    fi
186
+    # end of workaround
187
+  done
188
+  echo "${basedir}"
189
+}
190
+
191
+# concatenates all lines of a file
192
+concat_lines() {
193
+  if [ -f "$1" ]; then
194
+    echo "$(tr -s '\n' ' ' < "$1")"
195
+  fi
196
+}
197
+
198
+BASE_DIR=`find_maven_basedir "$(pwd)"`
199
+if [ -z "$BASE_DIR" ]; then
200
+  exit 1;
201
+fi
202
+
203
+export MAVEN_PROJECTBASEDIR=${MAVEN_BASEDIR:-"$BASE_DIR"}
204
+echo $MAVEN_PROJECTBASEDIR
205
+MAVEN_OPTS="$(concat_lines "$MAVEN_PROJECTBASEDIR/.mvn/jvm.config") $MAVEN_OPTS"
206
+
207
+# For Cygwin, switch paths to Windows format before running java
208
+if $cygwin; then
209
+  [ -n "$M2_HOME" ] &&
210
+    M2_HOME=`cygpath --path --windows "$M2_HOME"`
211
+  [ -n "$JAVA_HOME" ] &&
212
+    JAVA_HOME=`cygpath --path --windows "$JAVA_HOME"`
213
+  [ -n "$CLASSPATH" ] &&
214
+    CLASSPATH=`cygpath --path --windows "$CLASSPATH"`
215
+  [ -n "$MAVEN_PROJECTBASEDIR" ] &&
216
+    MAVEN_PROJECTBASEDIR=`cygpath --path --windows "$MAVEN_PROJECTBASEDIR"`
217
+fi
218
+
219
+WRAPPER_LAUNCHER=org.apache.maven.wrapper.MavenWrapperMain
220
+
221
+exec "$JAVACMD" \
222
+  $MAVEN_OPTS \
223
+  -classpath "$MAVEN_PROJECTBASEDIR/.mvn/wrapper/maven-wrapper.jar" \
224
+  "-Dmaven.home=${M2_HOME}" "-Dmaven.multiModuleProjectDirectory=${MAVEN_PROJECTBASEDIR}" \
225
+  ${WRAPPER_LAUNCHER} $MAVEN_CONFIG "$@"

+ 143
- 0
server/mvnw.cmd Dosyayı Görüntüle

@@ -0,0 +1,143 @@
1
+@REM ----------------------------------------------------------------------------
2
+@REM Licensed to the Apache Software Foundation (ASF) under one
3
+@REM or more contributor license agreements.  See the NOTICE file
4
+@REM distributed with this work for additional information
5
+@REM regarding copyright ownership.  The ASF licenses this file
6
+@REM to you under the Apache License, Version 2.0 (the
7
+@REM "License"); you may not use this file except in compliance
8
+@REM with the License.  You may obtain a copy of the License at
9
+@REM
10
+@REM    http://www.apache.org/licenses/LICENSE-2.0
11
+@REM
12
+@REM Unless required by applicable law or agreed to in writing,
13
+@REM software distributed under the License is distributed on an
14
+@REM "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
15
+@REM KIND, either express or implied.  See the License for the
16
+@REM specific language governing permissions and limitations
17
+@REM under the License.
18
+@REM ----------------------------------------------------------------------------
19
+
20
+@REM ----------------------------------------------------------------------------
21
+@REM Maven2 Start Up Batch script
22
+@REM
23
+@REM Required ENV vars:
24
+@REM JAVA_HOME - location of a JDK home dir
25
+@REM
26
+@REM Optional ENV vars
27
+@REM M2_HOME - location of maven2's installed home dir
28
+@REM MAVEN_BATCH_ECHO - set to 'on' to enable the echoing of the batch commands
29
+@REM MAVEN_BATCH_PAUSE - set to 'on' to wait for a key stroke before ending
30
+@REM MAVEN_OPTS - parameters passed to the Java VM when running Maven
31
+@REM     e.g. to debug Maven itself, use
32
+@REM set MAVEN_OPTS=-Xdebug -Xrunjdwp:transport=dt_socket,server=y,suspend=y,address=8000
33
+@REM MAVEN_SKIP_RC - flag to disable loading of mavenrc files
34
+@REM ----------------------------------------------------------------------------
35
+
36
+@REM Begin all REM lines with '@' in case MAVEN_BATCH_ECHO is 'on'
37
+@echo off
38
+@REM enable echoing my setting MAVEN_BATCH_ECHO to 'on'
39
+@if "%MAVEN_BATCH_ECHO%" == "on"  echo %MAVEN_BATCH_ECHO%
40
+
41
+@REM set %HOME% to equivalent of $HOME
42
+if "%HOME%" == "" (set "HOME=%HOMEDRIVE%%HOMEPATH%")
43
+
44
+@REM Execute a user defined script before this one
45
+if not "%MAVEN_SKIP_RC%" == "" goto skipRcPre
46
+@REM check for pre script, once with legacy .bat ending and once with .cmd ending
47
+if exist "%HOME%\mavenrc_pre.bat" call "%HOME%\mavenrc_pre.bat"
48
+if exist "%HOME%\mavenrc_pre.cmd" call "%HOME%\mavenrc_pre.cmd"
49
+:skipRcPre
50
+
51
+@setlocal
52
+
53
+set ERROR_CODE=0
54
+
55
+@REM To isolate internal variables from possible post scripts, we use another setlocal
56
+@setlocal
57
+
58
+@REM ==== START VALIDATION ====
59
+if not "%JAVA_HOME%" == "" goto OkJHome
60
+
61
+echo.
62
+echo Error: JAVA_HOME not found in your environment. >&2
63
+echo Please set the JAVA_HOME variable in your environment to match the >&2
64
+echo location of your Java installation. >&2
65
+echo.
66
+goto error
67
+
68
+:OkJHome
69
+if exist "%JAVA_HOME%\bin\java.exe" goto init
70
+
71
+echo.
72
+echo Error: JAVA_HOME is set to an invalid directory. >&2
73
+echo JAVA_HOME = "%JAVA_HOME%" >&2
74
+echo Please set the JAVA_HOME variable in your environment to match the >&2
75
+echo location of your Java installation. >&2
76
+echo.
77
+goto error
78
+
79
+@REM ==== END VALIDATION ====
80
+
81
+:init
82
+
83
+@REM Find the project base dir, i.e. the directory that contains the folder ".mvn".
84
+@REM Fallback to current working directory if not found.
85
+
86
+set MAVEN_PROJECTBASEDIR=%MAVEN_BASEDIR%
87
+IF NOT "%MAVEN_PROJECTBASEDIR%"=="" goto endDetectBaseDir
88
+
89
+set EXEC_DIR=%CD%
90
+set WDIR=%EXEC_DIR%
91
+:findBaseDir
92
+IF EXIST "%WDIR%"\.mvn goto baseDirFound
93
+cd ..
94
+IF "%WDIR%"=="%CD%" goto baseDirNotFound
95
+set WDIR=%CD%
96
+goto findBaseDir
97
+
98
+:baseDirFound
99
+set MAVEN_PROJECTBASEDIR=%WDIR%
100
+cd "%EXEC_DIR%"
101
+goto endDetectBaseDir
102
+
103
+:baseDirNotFound
104
+set MAVEN_PROJECTBASEDIR=%EXEC_DIR%
105
+cd "%EXEC_DIR%"
106
+
107
+:endDetectBaseDir
108
+
109
+IF NOT EXIST "%MAVEN_PROJECTBASEDIR%\.mvn\jvm.config" goto endReadAdditionalConfig
110
+
111
+@setlocal EnableExtensions EnableDelayedExpansion
112
+for /F "usebackq delims=" %%a in ("%MAVEN_PROJECTBASEDIR%\.mvn\jvm.config") do set JVM_CONFIG_MAVEN_PROPS=!JVM_CONFIG_MAVEN_PROPS! %%a
113
+@endlocal & set JVM_CONFIG_MAVEN_PROPS=%JVM_CONFIG_MAVEN_PROPS%
114
+
115
+:endReadAdditionalConfig
116
+
117
+SET MAVEN_JAVA_EXE="%JAVA_HOME%\bin\java.exe"
118
+
119
+set WRAPPER_JAR="%MAVEN_PROJECTBASEDIR%\.mvn\wrapper\maven-wrapper.jar"
120
+set WRAPPER_LAUNCHER=org.apache.maven.wrapper.MavenWrapperMain
121
+
122
+%MAVEN_JAVA_EXE% %JVM_CONFIG_MAVEN_PROPS% %MAVEN_OPTS% %MAVEN_DEBUG_OPTS% -classpath %WRAPPER_JAR% "-Dmaven.multiModuleProjectDirectory=%MAVEN_PROJECTBASEDIR%" %WRAPPER_LAUNCHER% %MAVEN_CONFIG% %*
123
+if ERRORLEVEL 1 goto error
124
+goto end
125
+
126
+:error
127
+set ERROR_CODE=1
128
+
129
+:end
130
+@endlocal & set ERROR_CODE=%ERROR_CODE%
131
+
132
+if not "%MAVEN_SKIP_RC%" == "" goto skipRcPost
133
+@REM check for post script, once with legacy .bat ending and once with .cmd ending
134
+if exist "%HOME%\mavenrc_post.bat" call "%HOME%\mavenrc_post.bat"
135
+if exist "%HOME%\mavenrc_post.cmd" call "%HOME%\mavenrc_post.cmd"
136
+:skipRcPost
137
+
138
+@REM pause the script if MAVEN_BATCH_PAUSE is set to 'on'
139
+if "%MAVEN_BATCH_PAUSE%" == "on" pause
140
+
141
+if "%MAVEN_TERMINATE_CMD%" == "on" exit %ERROR_CODE%
142
+
143
+exit /B %ERROR_CODE%

+ 66
- 0
server/pom.xml Dosyayı Görüntüle

@@ -0,0 +1,66 @@
1
+<?xml version="1.0" encoding="UTF-8"?>
2
+<project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
3
+	xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
4
+	<modelVersion>4.0.0</modelVersion>
5
+
6
+	<groupId>com.stockr</groupId>
7
+	<artifactId>server</artifactId>
8
+	<version>0.0.1-SNAPSHOT</version>
9
+	<packaging>jar</packaging>
10
+
11
+	<name>server</name>
12
+	<description>Stockr Main Server</description>
13
+
14
+	<parent>
15
+		<groupId>org.springframework.boot</groupId>
16
+		<artifactId>spring-boot-starter-parent</artifactId>
17
+		<version>2.0.3.RELEASE</version>
18
+		<relativePath/> <!-- lookup parent from repository -->
19
+	</parent>
20
+
21
+	<properties>
22
+		<project.build.sourceEncoding>UTF-8</project.build.sourceEncoding>
23
+		<project.reporting.outputEncoding>UTF-8</project.reporting.outputEncoding>
24
+		<java.version>1.8</java.version>
25
+	</properties>
26
+
27
+	<dependencies>
28
+		<dependency>
29
+			<groupId>org.springframework.boot</groupId>
30
+			<artifactId>spring-boot-starter-actuator</artifactId>
31
+		</dependency>
32
+		<dependency>
33
+			<groupId>org.springframework.boot</groupId>
34
+			<artifactId>spring-boot-starter-web</artifactId>
35
+		</dependency>
36
+
37
+		<dependency>
38
+			<groupId>org.springframework.boot</groupId>
39
+			<artifactId>spring-boot-starter-test</artifactId>
40
+			<scope>test</scope>
41
+		</dependency>
42
+
43
+		<dependency>
44
+			<groupId>org.projectlombok</groupId>
45
+			<artifactId>lombok</artifactId>
46
+			<version>1.16.8</version>
47
+			<scope>provided</scope>
48
+		</dependency>
49
+
50
+		<dependency>
51
+			<groupId>com.fasterxml.jackson.core</groupId>
52
+			<artifactId>jackson-databind</artifactId>
53
+		</dependency>
54
+	</dependencies>
55
+
56
+	<build>
57
+		<plugins>
58
+			<plugin>
59
+				<groupId>org.springframework.boot</groupId>
60
+				<artifactId>spring-boot-maven-plugin</artifactId>
61
+			</plugin>
62
+		</plugins>
63
+	</build>
64
+
65
+
66
+</project>

+ 12
- 0
server/src/main/java/com/stockr/server/ServerApplication.java Dosyayı Görüntüle

@@ -0,0 +1,12 @@
1
+package com.stockr.server;
2
+
3
+import org.springframework.boot.SpringApplication;
4
+import org.springframework.boot.autoconfigure.SpringBootApplication;
5
+
6
+@SpringBootApplication
7
+public class ServerApplication {
8
+
9
+	public static void main(String[] args) {
10
+		SpringApplication.run(ServerApplication.class, args);
11
+	}
12
+}

+ 26
- 0
server/src/main/java/com/stockr/server/news/Article.java Dosyayı Görüntüle

@@ -0,0 +1,26 @@
1
+package com.stockr.server.news;
2
+
3
+import com.fasterxml.jackson.annotation.JsonProperty;
4
+import lombok.Getter;
5
+import lombok.Setter;
6
+
7
+import java.util.Map;
8
+
9
+@Getter @Setter
10
+class Article {
11
+    private String sourceId;
12
+    private String sourceName;
13
+    private String author;
14
+    private String title;
15
+    private String description;
16
+    private String url;
17
+    private String urlToImage;
18
+    private String publishedAt;
19
+
20
+    @SuppressWarnings("unused")
21
+    @JsonProperty("source")
22
+    private void unpackSource(Map<String, Object> source) {
23
+        this.sourceId = (String)source.get("id");
24
+        this.sourceName = (String)source.get("name");
25
+    }
26
+}

+ 15
- 0
server/src/main/java/com/stockr/server/news/News.java Dosyayı Görüntüle

@@ -0,0 +1,15 @@
1
+package com.stockr.server.news;
2
+
3
+import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
4
+import lombok.Getter;
5
+import lombok.Setter;
6
+
7
+import java.util.ArrayList;
8
+
9
+@Getter @Setter
10
+@JsonIgnoreProperties
11
+class News {
12
+    // Wrapper to take articles
13
+    private ArrayList<Article> articles = new ArrayList<>();
14
+}
15
+

+ 18
- 0
server/src/main/java/com/stockr/server/news/NewsController.java Dosyayı Görüntüle

@@ -0,0 +1,18 @@
1
+package com.stockr.server.news;
2
+
3
+import org.springframework.beans.factory.annotation.Autowired;
4
+import org.springframework.web.bind.annotation.*;
5
+
6
+import java.util.ArrayList;
7
+
8
+@RestController
9
+@RequestMapping("news")
10
+public class NewsController {
11
+    @Autowired
12
+    NewsService ns;
13
+
14
+    @GetMapping// root
15
+    public ArrayList<Article> getAllArticles(@RequestParam("query") String query){
16
+        return ns.getAllArticles(query);
17
+    }
18
+}

+ 29
- 0
server/src/main/java/com/stockr/server/news/NewsControllerAdvice.java Dosyayı Görüntüle

@@ -0,0 +1,29 @@
1
+package com.stockr.server.news;
2
+
3
+import com.fasterxml.jackson.databind.ObjectMapper;
4
+import com.fasterxml.jackson.databind.node.ObjectNode;
5
+import org.springframework.http.ResponseEntity;
6
+import org.springframework.web.bind.MissingServletRequestParameterException;
7
+import org.springframework.web.bind.annotation.ControllerAdvice;
8
+import org.springframework.web.bind.annotation.ExceptionHandler;
9
+
10
+import java.io.IOException;
11
+
12
+@ControllerAdvice(basePackageClasses = NewsControllerAdvice.class)
13
+public class NewsControllerAdvice {
14
+    private ObjectMapper om = new ObjectMapper();
15
+
16
+    @ExceptionHandler(MissingServletRequestParameterException.class)
17
+    public ResponseEntity<Object> handleMissingParams(MissingServletRequestParameterException ex) throws IOException {
18
+        return ResponseEntity
19
+                .badRequest()
20
+                .body(removeStackTrace(ex));
21
+    }
22
+
23
+    ObjectNode removeStackTrace(Exception ex) throws IOException {
24
+        String exAsString = om.writeValueAsString(ex);
25
+        ObjectNode o = om.readValue(exAsString, ObjectNode.class);
26
+        o.remove("stackTrace");
27
+        return o;
28
+    }
29
+}

+ 53
- 0
server/src/main/java/com/stockr/server/news/NewsService.java Dosyayı Görüntüle

@@ -0,0 +1,53 @@
1
+package com.stockr.server.news;
2
+
3
+import org.springframework.boot.web.client.RestTemplateBuilder;
4
+import org.springframework.http.HttpEntity;
5
+import org.springframework.http.HttpHeaders;
6
+import org.springframework.http.HttpMethod;
7
+import org.springframework.http.ResponseEntity;
8
+import org.springframework.stereotype.Service;
9
+import org.springframework.web.client.RestTemplate;
10
+
11
+import java.util.ArrayList;
12
+
13
+@Service
14
+public class NewsService {
15
+    // TODO - hide key(?)
16
+    private final String key = "471b872d96ca40c4a1d0f21de4bb061e";
17
+    private final RestTemplate rt;
18
+    private HttpEntity entity;
19
+
20
+    public NewsService(RestTemplateBuilder rtb) {
21
+        initHeaders();
22
+        rt = rtb.build();
23
+    }
24
+
25
+    private void initHeaders() {
26
+        HttpHeaders headers = new HttpHeaders();
27
+        headers.set("X-Api-Key", key);
28
+        entity = new HttpEntity(headers);
29
+    }
30
+
31
+    News getNews(String query) {
32
+        ResponseEntity<News> re = rt.exchange(
33
+                insertQueryInUrl(query),
34
+                HttpMethod.GET,
35
+                entity,
36
+                News.class
37
+        );
38
+        News n = re.getBody();
39
+        return n;
40
+    }
41
+
42
+    ArrayList<Article> getAllArticles(String query) {
43
+        return getNews(query)
44
+                .getArticles();
45
+    }
46
+
47
+    String insertQueryInUrl(String query) {
48
+        return  "https://newsapi.org/v2/everything?q=" + query +
49
+                "&language=en" +
50
+                "&sources=bloomberg,business-insider,cnbc,the-wall-street-journal" +
51
+                "&pageSize=100";
52
+    }
53
+}

+ 0
- 0
server/src/main/resources/application.properties Dosyayı Görüntüle


+ 16
- 0
server/src/test/java/com/stockr/server/ServerApplicationTests.java Dosyayı Görüntüle

@@ -0,0 +1,16 @@
1
+package com.stockr.server;
2
+
3
+import org.junit.Test;
4
+import org.junit.runner.RunWith;
5
+import org.springframework.boot.test.context.SpringBootTest;
6
+import org.springframework.test.context.junit4.SpringRunner;
7
+
8
+@RunWith(SpringRunner.class)
9
+public class ServerApplicationTests {
10
+
11
+	@Test
12
+	public void ServerApplication_Should_Start() {
13
+		ServerApplication.main(new String[] {});
14
+	}
15
+
16
+}

+ 23
- 0
server/src/test/java/com/stockr/server/news/ArticleTest.java Dosyayı Görüntüle

@@ -0,0 +1,23 @@
1
+package com.stockr.server.news;
2
+
3
+import com.fasterxml.jackson.databind.ObjectMapper;
4
+import org.junit.Test;
5
+
6
+import java.io.IOException;
7
+
8
+import static org.junit.Assert.*;
9
+
10
+public class ArticleTest {
11
+    @Test
12
+    public void unpackSource_ShouldGetNestedValues() throws IOException {
13
+        ObjectMapper om = new ObjectMapper();
14
+        String JSON = "{\"source\":" +
15
+                        " {\"id\": \"ID\"," +
16
+                        " \"name\": \"NAME\"}" +
17
+                      "}";
18
+
19
+        Article a = om.readValue(JSON, Article.class);
20
+        assertEquals("ID", a.getSourceId());
21
+        assertEquals("NAME", a.getSourceName());
22
+    }
23
+}

+ 21
- 0
server/src/test/java/com/stockr/server/news/NewsControllerAdviceTest.java Dosyayı Görüntüle

@@ -0,0 +1,21 @@
1
+package com.stockr.server.news;
2
+
3
+import com.fasterxml.jackson.databind.node.ObjectNode;
4
+import org.junit.Before;
5
+import org.junit.Test;
6
+
7
+import java.io.IOException;
8
+
9
+import static org.junit.Assert.*;
10
+
11
+public class NewsControllerAdviceTest {
12
+    NewsControllerAdvice nca = new NewsControllerAdvice();
13
+
14
+    @Test
15
+    public void removeStackTrace_ShouldRemoveStackTrace() throws IOException {
16
+        Exception ex = new Exception();
17
+        ex.fillInStackTrace();
18
+
19
+        assertNull(nca.removeStackTrace(ex).get("stackTrace"));
20
+    }
21
+}

+ 55
- 0
server/src/test/java/com/stockr/server/news/NewsControllerTest.java Dosyayı Görüntüle

@@ -0,0 +1,55 @@
1
+package com.stockr.server.news;
2
+
3
+import static org.hamcrest.Matchers.containsString;
4
+import static org.mockito.Mockito.when;
5
+import static org.springframework.test.web.servlet.request.MockMvcRequestBuilders.get;
6
+import static org.springframework.test.web.servlet.result.MockMvcResultHandlers.print;
7
+import static org.springframework.test.web.servlet.result.MockMvcResultMatchers.content;
8
+import static org.springframework.test.web.servlet.result.MockMvcResultMatchers.handler;
9
+import static org.springframework.test.web.servlet.result.MockMvcResultMatchers.status;
10
+
11
+import org.junit.Ignore;
12
+import org.junit.Test;
13
+import org.junit.runner.RunWith;
14
+import org.springframework.beans.factory.annotation.Autowired;
15
+import org.springframework.boot.test.autoconfigure.web.servlet.WebMvcTest;
16
+import org.springframework.boot.test.mock.mockito.MockBean;
17
+import org.springframework.http.HttpHeaders;
18
+import org.springframework.http.HttpStatus;
19
+import org.springframework.test.context.junit4.SpringRunner;
20
+import org.springframework.test.web.servlet.MockMvc;
21
+
22
+@RunWith(SpringRunner.class)
23
+@WebMvcTest(NewsController.class)
24
+public class NewsControllerTest {
25
+
26
+    @Autowired
27
+    private MockMvc mockMvc;
28
+
29
+    @MockBean
30
+    private NewsService service;
31
+
32
+    @Test
33
+    public void news_ShouldUseMethod_getAllArticles() throws Exception {
34
+        when(service.getNews("test")).thenReturn(new News());
35
+        this.mockMvc.perform(get("/news?query=fb"))
36
+                .andDo(print())
37
+                .andExpect(handler().methodName("getAllArticles"));
38
+    }
39
+
40
+    @Test
41
+    public void news_ShouldReturnJsonArray() throws Exception {
42
+        when(service.getNews("test")).thenReturn(new News());
43
+        this.mockMvc.perform(get("/news?query=fb"))
44
+                .andDo(print())
45
+                .andExpect(content().string("[]"));
46
+    }
47
+
48
+    @Test
49
+    public void news_ShouldHaveBadRequest_WhenNoQueries() throws Exception {
50
+        when(service.getNews("test")).thenReturn(new News());
51
+        this.mockMvc.perform(get("/news"))
52
+                .andDo(print())
53
+                .andExpect(status().isBadRequest());
54
+    }
55
+}

+ 96
- 0
server/src/test/java/com/stockr/server/news/NewsServiceTest.java Dosyayı Görüntüle

@@ -0,0 +1,96 @@
1
+package com.stockr.server.news;
2
+
3
+import com.fasterxml.jackson.core.JsonProcessingException;
4
+import com.fasterxml.jackson.databind.ObjectMapper;
5
+import org.hamcrest.Matchers;
6
+import org.junit.Before;
7
+import org.junit.Test;
8
+import org.junit.runner.RunWith;
9
+import org.springframework.beans.factory.annotation.Autowired;
10
+import org.springframework.boot.test.autoconfigure.web.client.RestClientTest;
11
+import org.springframework.http.HttpMethod;
12
+import org.springframework.http.MediaType;
13
+import org.springframework.test.context.junit4.SpringRunner;
14
+import org.springframework.test.web.client.MockRestServiceServer;
15
+
16
+import java.util.ArrayList;
17
+
18
+import static org.junit.Assert.*;
19
+import static org.springframework.test.web.client.match.MockRestRequestMatchers.header;
20
+import static org.springframework.test.web.client.match.MockRestRequestMatchers.method;
21
+import static org.springframework.test.web.client.match.MockRestRequestMatchers.requestTo;
22
+import static org.springframework.test.web.client.response.MockRestResponseCreators.withSuccess;
23
+
24
+@RunWith(SpringRunner.class)
25
+@RestClientTest(NewsService.class)
26
+public class NewsServiceTest {
27
+    @Autowired
28
+    private NewsService ns;
29
+
30
+    @Autowired
31
+    private MockRestServiceServer mrss;
32
+
33
+    @Autowired
34
+    private ObjectMapper om;
35
+
36
+    private String JSON;
37
+
38
+    @Before
39
+    public void setUp() throws JsonProcessingException {
40
+        setUpJsonResponse();
41
+        setUpMrss();
42
+    }
43
+
44
+    private void setUpMrss() {
45
+        mrss.expect(requestTo(ns.insertQueryInUrl("test")))
46
+                .andExpect(method(HttpMethod.GET))
47
+                .andExpect(header("X-Api-Key", Matchers.containsString("")))
48
+                .andRespond(withSuccess(JSON, MediaType.APPLICATION_JSON));
49
+    }
50
+
51
+    private void setUpJsonResponse() throws JsonProcessingException {
52
+        ArrayList<Article> al = new ArrayList<>();
53
+        Article a = new Article();
54
+        a.setAuthor("Author Name");
55
+        al.add(a);
56
+        News n = new News();
57
+        n.setArticles(al);
58
+        JSON = om.writeValueAsString(n);
59
+    }
60
+
61
+    @Test
62
+    public void getNews_ShouldHitTheProperEndpoint() {
63
+        ns.getNews("test");
64
+        mrss.verify();
65
+    }
66
+
67
+    @Test
68
+    public void getNewsShouldSendXApiKeyHeader() {
69
+        ns.getNews("test");
70
+        mrss.verify();
71
+    }
72
+
73
+    @Test
74
+    public void getNews_ShouldParseJsonProperly() {
75
+        News ne = ns.getNews("test");
76
+        assertEquals("Author Name", ne.getArticles().get(0).getAuthor());
77
+    }
78
+
79
+    @Test
80
+    public void getAllArticles_ShouldReturnArrayList() {
81
+        ArrayList ne = ns.getAllArticles("test");
82
+        assertNotNull(ne);
83
+    }
84
+
85
+
86
+    @Test
87
+    public void insertQueryInUrl_ShouldPassQueryIntoUrl() {
88
+        String query = "tesla";
89
+        String expected = "https://newsapi.org/v2/everything?q=" + query +
90
+                "&language=en" +
91
+                "&sources=bloomberg,business-insider,cnbc,the-wall-street-journal" +
92
+                "&pageSize=100";
93
+        String actual = ns.insertQueryInUrl(query);
94
+        assertEquals(expected, actual);
95
+    }
96
+}